package com.scbfkj.uni.api;

import com.fasterxml.jackson.databind.ser.std.MapSerializer;
import com.scbfkj.uni.library.RequestUtil;
import com.scbfkj.uni.process.DataBase;
import com.scbfkj.uni.service.DataProcessService;
import com.scbfkj.uni.system.Config;
import org.springframework.http.HttpStatusCode;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.Collections;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("openApi")
public class GenericApi {

    @PostMapping({"newdata", "modifydata", "movedata", "query"})
    public ResponseEntity<Map<String,Object>> base(@RequestBody Map<String, Object> body) throws Exception {
        String uri = RequestUtil.getUri();
        String event = "0";

        if (uri.endsWith("newdata")) {
            event = "1";
        } else if (uri.endsWith("modifydata")) {
            event = "2";
        } else if (uri.endsWith("movedata")) {
            event = "3";
        } else if (uri.endsWith("query")) {
            event = "0";
        }
        body.put("event", event);

        Map<String, Object> process = DataProcessService.process(body);
        return ResponseEntity.ok(process);
    }

    /**
     * 匹配服务的暴露的接口
     *
     * @param body
     * @return
     * @throws Exception
     */

    @PostMapping("{path}")
    public ResponseEntity<Map<String,Object>> matchService(@RequestBody Map<String, Object> body) throws Exception {
        String uri = RequestUtil.getUri();
        List<Map<String, Object>> serviceinfoList = DataBase.query(Config.centerConnectionStr, "select * from serviceinfo where urilist like concat('%',?,'%')", Collections.singletonList(new Object[]{uri}));

        if (serviceinfoList.isEmpty()) {
            return ResponseEntity.status(HttpStatusCode.valueOf(404)).build();
        }
        Map<String, Object> process = DataProcessService.process(body);
        return ResponseEntity.ok(process);
    }
}
