package com.scbfkj.uni.library;

import com.scbfkj.uni.process.DataBase;
import com.scbfkj.uni.system.Config;

import java.util.*;

public class DataAliasGetUtil {


    private static List<Map<String, Object>> keyAlias = null;

    public static Optional<String> getValue(String key, Map<String, Object> data) throws Exception {

        if (Objects.isNull(data)) return Optional.empty();
        Optional<String> result = Optional.ofNullable(data.get(key)).map(Object::toString);
        if (result.isPresent()) return result;
        if (Objects.isNull(keyAlias) || keyAlias.isEmpty()) {

            keyAlias = DataBase.query(Config.centerConnectionStr, "select * from keyalias where aliasid>?", Collections.singletonList(new Object[]{0}));

        }
        List<Map<String, Object>> keynames = keyAlias.stream().filter(it -> Objects.equals(it.get("keyname"), key)).toList();
        if (keynames.isEmpty()) return Optional.empty();
        return keynames.stream().map(it -> it.get("aliasname")).map(data::get).filter(Objects::nonNull).map(Object::toString).findAny();
    }


    private static long sequence = 0L;
    private static long lastTimestamp = -1L;
    public synchronized static String createLifeCycleCol(String containerCode, String serviceId) {
        long timestamp = System.currentTimeMillis();
        //如果当前时间小于上一次ID生成的时间戳，说明系统时钟回退过这个时候应当抛出异常
        if (lastTimestamp == timestamp) { //如果是同一时间生成的，则进行毫秒内序列
            sequence++;
            if (sequence > 999L) {//毫秒内序列溢出
                sequence = 0;
                while (lastTimestamp == System.currentTimeMillis()) {//阻塞到下一个毫秒,获得新的时间戳
                }
                timestamp = System.currentTimeMillis();
            }
        } else {
            sequence = 0L;
        }
        lastTimestamp = timestamp;//上次生成ID的时间截
        //移位并通过或运算拼到一起组成64位的ID
        return String.valueOf(timestamp).concat(String.format("%03d", sequence)).concat(String.format("%6s", containerCode)).concat(String.format("%6s", serviceId)).replaceAll("\\s", "0");
    }
}
