package com.scbfkj.uni.service;

import com.jayway.jsonpath.JsonPath;
import com.scbfkj.uni.library.DataFormatUtil;
import com.scbfkj.uni.library.UniReturnUtil;
import com.scbfkj.uni.library.script.DatabaseScriptUtil;
import com.scbfkj.uni.process.DataBase;
import com.scbfkj.uni.process.Elasticsearch;
import com.scbfkj.uni.process.Kafka;
import com.scbfkj.uni.system.Config;
import org.springframework.stereotype.Component;

import java.io.File;
import java.io.FileNotFoundException;
import java.sql.*;
import java.time.LocalDateTime;
import java.util.*;

@Component
public class LoggerService {

    private static String logConnection = """
            {"jdbcUrl":"jdbc:sqlite:logs/log_","driverClassName":"org.sqlite.JDBC"}""";

    private static Map<String, Integer> flag = new HashMap<>();

    //写日志方法：log()--提供给程序内部使用
    //用户操作日志
    public static void logUser(LocalDateTime requestTime, String requestIP, String requestPath
            , String requestData, String sessionID, LocalDateTime returnDate
            , String returnData, String returnCode, String returnMessage
            , String dataObjectID, String applicationID, String userID) {
        //调用工具类的获取雪花编号getUniqueNumber(时间戳+当前容器编号+0)
        //打开雪花编号对应的临时Sqlite（日志文件夹下）
        //写入数据
    }

    //接口日志
    public static void logInterface(LocalDateTime requestTime, String requestIP, String requestPath
            , String requestData, String sessionID, LocalDateTime returnDate
            , String returnData, String returnCode, String returnMessage
            , String dataObjectID, String applicationID) {
        //
        //调用工具类的获取雪花编号getUniqueNumber(时间戳+当前容器编号+0)
        //打开雪花编号对应的临时Sqlite（日志文件夹下）
        //写入数据
    }

    /**
     * @param beginTime     算法开始时间
     * @param serviceID     服务id
     * @param resource      算法数据历史
     * @param preResource   前置算法
     * @param endTime       算法结束时间
     * @param returnCode    算法结果成功失败编号
     * @param returnMessage 算法失败错误消息
     * @param dataObjectID  数据声明周期
     */
    //服务日志
    public static void logService(LocalDateTime beginTime, String serviceID, String resource, String preResource,
                                  LocalDateTime endTime,
                                  String returnCode, String returnMessage
            , String dataObjectID) {
        //调用工具类的获取雪花编号getUniqueNumber(时间戳+当前容器编号+0)
        //打开雪花编号对应的临时Sqlite（日志文件夹下）
        //写入数据
//
//        try {
//            String tableName = "servicelog";
//            String connectionStr = getCurrentThreadConnection(tableName);
//            if (!Objects.equals(returnCode, "0")) {
//                tableName = "serviceerrlog";
//            }
////            insertLog(connectionStr,
////                    "insert into %s ('begintime','endtime','serviceid','resource','preresource','returncode','returnmessage','lifecycleid') values (?,?,?,?,?,?,?,?,?)".formatted(tableName),
////                    List.of(beginTime, endTime, serviceID, resource, preResource, returnCode, returnMessage, dataObjectID));
//        } catch (Exception e) {
//            e.printStackTrace();
//            System.out.println(UniReturnUtil.getMessage(e));
//        }
    }

    //系统异常日志
    public static void logSystemError(LocalDateTime occurrenceTime, String occurrenceAddress
            , String detailedMessage) {
        //调用工具类的获取雪花编号getUniqueNumber(时间戳+当前容器编号+0)
        //打开雪花编号对应的临时Sqlite（日志文件夹下）
        //写入数据

        try {
            String tableName = "systemerrlog";
            String connectionStr = getCurrentThreadConnection(tableName);
            insertLog(connectionStr,
                    "insert into %s ('occurrenceTime','occurrenceAddress','detailedMessage') values (?,?,?)".formatted(tableName),
                    List.of(occurrenceTime, occurrenceAddress, detailedMessage));
        } catch (Exception e) {
            System.out.println(UniReturnUtil.getMessage(e));
        }
    }

    private static String getCurrentThreadConnection(String targetName) throws Exception {
        long id = Thread.currentThread().getId();

        String fileName = "logs" + File.separator + "log_" + id + "_" + targetName;
        File file = new File(fileName);
        HashMap<String, Object> connectionMap = new HashMap<>();

        connectionMap.put("jdbcUrl", "jdbc:sqlite:" + file.getPath());
        connectionMap.put("driverClassName", "org.sqlite.JDBC");
        String newConnection = DataFormatUtil.toString(connectionMap);
        if (!file.exists()) {
            String sql = null;
            if (targetName.equals("interfacelog")) {
                sql = """
                        CREATE TABLE interfacelog (
                             
                            logid         Integer
                                primary key autoincrement,
                            requesttime DATETIME,
                            requestip TEXT,
                            requestpath TEXT,
                            requestdata TEXT,
                            sessionid TEXT,
                            returndate DATETIME,
                            returndata TEXT,
                            returncode TEXT,
                            returnmessage TEXT,
                            dataobjectid TEXT,
                            applicationid TEXT
                         )
                                                """;
            } else if (targetName.equals("servicelog")) {
                sql = """
                        CREATE TABLE servicelog (
                             
                            logid         Integer
                                primary key autoincrement,
                             begintime DATETIME,
                             endtime DATETIME,
                             serviceid TEXT,
                             resource TEXT,
                             requestdata TEXT,
                             returndata TEXT,
                             returncode TEXT,
                             returnmessage TEXT,
                             lifecycleid TEXT
                         )
                                                                        """;
            } else if (targetName.equals("serviceerrlog")) {
                sql = """
                        CREATE TABLE serviceerrlog (
                             
                            logid         Integer
                                primary key autoincrement,
                             begintime DATETIME,
                             endtime DATETIME,
                             serviceid TEXT,
                             resource TEXT,
                             requestdata TEXT,
                             returndata TEXT,
                             returncode TEXT,
                             returnmessage TEXT,
                             lifecycleid TEXT
                         )
                        """;
            } else if (targetName.equals("systemerrlog")) {
                sql = """
                        create table systemerrlog
                         (
                             logid         Integer
                                 primary key autoincrement,
                             occurrencetime DATETIME,
                             occurrenceaddress TEXT,
                             detailedmessage TEXT
                         );


                                                 """;
            } else if (targetName.equals("userlog")) {
                sql = """
                        CREATE TABLE userlog (
                              
                            logid         Integer
                                primary key autoincrement,
                            requesttime DATETIME,
                            requestip TEXT,
                            requestpath TEXT,
                            requestdata TEXT,
                            sessionid TEXT,
                            returndate DATETIME,
                            returndata TEXT,
                            returncode TEXT,
                            returnmessage TEXT,
                            dataobjectid TEXT,
                            applicationid TEXT,
                            userid TEXT
                          )
                        """;
            }
//            创建表结构
            DataBase.exec(newConnection, sql);
            try (Connection connection = createConnection(newConnection);
                 Statement statement = connection.createStatement()
            ) {
                statement.execute(sql);
            }

        }
        return newConnection;
    }

    /**
     * 读取日志并发送到目标存储介质，最后删除已经发送成功的日志
     *
     * @param fileName
     * @return
     */
    private static void apply(String fileName) {
        String newConnection = logConnection.replace("log_", fileName);
        String tableName = fileName.substring(fileName.lastIndexOf("_") + 1);
        try {
            List<Map<String, Object>> result = DataBase.query(newConnection, "select * from %s where 1=?".formatted(tableName), Collections.singletonList(new Object[]{1}));
            if (result.isEmpty()) {
                if (!flag.containsKey(fileName)) {
                    flag.put(fileName, 0);
                }
                int value = flag.get(fileName) + 1;
                if (value > 10) {
                    new File("logs" + File.separator + fileName).delete();
                    flag.remove(fileName);
                    return;
                } else {
                    flag.put(fileName, value);

                }

            } else {
                if (!flag.containsKey(fileName)) {
                    flag.put(fileName, 0);
                }
                flag.put(fileName, 0);
            }
//           删除成功的日志
            if (!result.isEmpty()) {
                for (String target : Config.targets) {
                    Object type = JsonPath.read(target, "$.type");
                    if (Objects.isNull(type)) throw new RuntimeException("日志输出目标类型没有配置");
                    switch (type.toString()) {
                        case "DB" -> {
                            DatabaseScriptUtil.exec(target, tableName, result, "1", null, null);
                        }
                        case "KAFKA" -> {
                            Kafka.sendMessage(target, tableName, result.stream().map(DataFormatUtil::toString).toList());
                        }
                        case "ES" -> {
                            Elasticsearch.send(target, tableName, result);
                        }
                    }
                }
                DatabaseScriptUtil.exec(newConnection, tableName, result.stream().map(it -> (Map<String, Object>) new HashMap<String, Object>() {{
                    put("logid", it.get("logid"));
                }}).toList(), "3", null, null);
            }
        } catch (Exception e) {
            System.out.println(UniReturnUtil.getMessage(e));
        }

    }

    public static void sendLog() throws FileNotFoundException {
        File logDir = new File("logs");
        if (logDir.exists()) {
            if (logDir.isDirectory()) {
                File[] files = logDir.listFiles();


                List<File> logs = new ArrayList<>();
                if (files != null) {
                    logs = Arrays.stream(files).toList();
                }
                logs.parallelStream().forEach(it -> {
                    String fileName = it.getName();
                    apply(fileName);
                });

            } else {
                throw new FileNotFoundException("logs 不是文件夹");
            }
        } else {
            throw new FileNotFoundException("日志目录没有找到");
        }
    }

    private static void insertLog(String connection, String sql, List<Object> args) {
        try (
                Connection connect = createConnection(connection);
                PreparedStatement preparedStatement = connect.prepareStatement(sql)) {
            for (int i = 0; i < args.size(); i++) {
                preparedStatement.setObject(i + 1, args.get(i));
            }
            preparedStatement.executeUpdate();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }
    }

    private List<Map<String, Object>> query(String connection, String sql) {
        try (
                Connection connect = createConnection(connection);
                PreparedStatement preparedStatement = connect.prepareStatement(sql)) {

            ResultSet resultSet = preparedStatement.executeQuery();
            return DataBase.getResult(connection, sql, resultSet);
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }
    }

    private static Connection createConnection(String connection) throws SQLException {
        Map<?, ?> map = DataFormatUtil.toMap(connection);
        String jdbcUrl = DataFormatUtil.toString(map.get("jdbcUrl"));
        String driverClassName = DataFormatUtil.toString(map.get("driverClassName"));
        Driver driver = DriverManager.getDriver(driverClassName);
        return driver.connect(jdbcUrl, null);
    }

}
