package com.scbfkj.uni.api;

import com.scbfkj.uni.ControllerBaseTest;
import org.hamcrest.collection.IsCollectionWithSize;
import org.hamcrest.core.IsEqual;
import org.junit.jupiter.api.Test;
import org.springframework.http.MediaType;
import org.springframework.test.web.servlet.request.MockMvcRequestBuilders;
import org.springframework.test.web.servlet.result.MockMvcResultHandlers;
import org.springframework.test.web.servlet.result.MockMvcResultMatchers;

public class TableConfigurationControllerTest extends ControllerBaseTest {

    @Test
    void testQuery() throws Exception {

        mockMvc.perform(MockMvcRequestBuilders.post("/openApi/query")
                        .contentType(MediaType.APPLICATION_JSON_VALUE)
//                        .header("token", token)
                        .content("""
                                {"serviceid":3,"datacontent":{"filter":{"pagecode":"applicationManagementTable"}},"event":"0"}
                                """)
                        .cookie(cookie))

                .andExpect(MockMvcResultMatchers.status().isOk())
                .andExpect(MockMvcResultMatchers.jsonPath("code", IsEqual.equalTo("0")))
                .andExpect(MockMvcResultMatchers.jsonPath("returnData", IsCollectionWithSize.hasSize(15)))
                .andDo(MockMvcResultHandlers.print());
    }
}
