package com.scbfkj.uni.process;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.scbfkj.uni.library.DataFormatUtil;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;
import static com.scbfkj.uni.library.script.DatabaseScriptUtil.exec;

import java.util.*;

import static org.junit.jupiter.api.Assertions.*;

@SpringBootTest
class DataBaseTest {
    static String connectionStr = """
                            {
              "jdbcUrl": "jdbc:mysql://120.26.64.82:3306/mid_log",
              "username": "root",
              "password": "123@bigdata",
              "driverClassName": "com.mysql.cj.jdbc.Driver"
            }""";
    public static String tableName = "log_error";

  static    List<Map<String, Object>> insert = Collections.singletonList(new HashMap<>() {{
        put("filter", new HashMap<>() {{
            put("id", 15);
        }});
        put("value", new HashMap<>() {{
            put("id", 15);
        }});
    }});

    static List<Map<String, Object>> update = Collections.singletonList(new HashMap<>() {{
        put("filter", new HashMap<>() {{
            put("id", 15);
        }});
        put("value", new HashMap<>() {{
            put("serviceid", 999);
            put("id", 15);
        }});
    }});

  static   List<Map<String, Object>> insertOrupdate = new ArrayList<>() {{
        add(new HashMap<>() {{
            put("filter", new HashMap<>() {{
                put("id", 15);
            }});
            put("value", new HashMap<>() {{
                put("serviceid", 1000);
                put("id", 15);
            }});
        }});
        add(new HashMap<>() {{
            put("filter", new HashMap<>() {{
                put("id", 16);
            }});
            put("value", new HashMap<>() {{
                put("serviceid", 1000);
                put("id", 16);
            }});
        }});
    }};
   static List<String> filterColumns = new ArrayList<>() {{
        add("id");
        add("serviceid");
    }};
   static List<Map<String, Object>> filterLines = new ArrayList<Map<String,Object>>(){{
       add(new HashMap<>(){{
           put("left","(");
           put("column","id");
           put("comparator","=");
           put("value",15);
           put("right",")");
       }});
   }};

    @Test
    void testExec() throws Exception {



        Map<String, Object> exec = exec(connectionStr, tableName, insert, "3", filterColumns, filterLines);
        System.out.println(DataFormatUtil.toString(exec));
        exec = exec(connectionStr, tableName, insert, "1", filterColumns, filterLines);
        System.out.println(DataFormatUtil.toString(exec));
        exec = exec(connectionStr, tableName, insert, "0", filterColumns, filterLines);
        System.out.println(DataFormatUtil.toString(exec));
        exec = exec(connectionStr, tableName, update, "2", filterColumns, filterLines);
        System.out.println(DataFormatUtil.toString(exec));
        exec = exec(connectionStr, tableName, update, "0", filterColumns, filterLines);
        System.out.println(DataFormatUtil.toString(exec));
        exec = exec(connectionStr, tableName, insertOrupdate, "6", filterColumns, filterLines);
        System.out.println(DataFormatUtil.toString(exec));
        exec = exec(connectionStr, tableName, insertOrupdate, "0", filterColumns, filterLines);
        System.out.println(DataFormatUtil.toString(exec));
    }

    @Test
    public void testWhereStr() throws Exception {
        Map<String, Object> exec = exec(connectionStr, "select * from %s where 《whereStr》".formatted(tableName), insert, "0", filterColumns, filterLines);
        System.out.println(DataFormatUtil.toString(exec));
    }
    @Test
    public void testBookTitleSymbol() throws Exception {
        Map<String, Object> exec = exec(connectionStr, "select * from %s where id=《id》".formatted(tableName), insert, "0", filterColumns, filterLines);
        System.out.println(DataFormatUtil.toString(exec));
    }
    @Test
    public void testBookTitleSymbol2() throws Exception {
        Map<String, Object> exec = exec(connectionStr, "select * from %s where id=《id》".formatted(tableName), insert.stream().map(it-> ((Map<String,Object>) it.get("filter"))).toList(), "0", filterColumns, filterLines);
        System.out.println(DataFormatUtil.toString(exec));
    }
    @Test
    public void testFilter() throws Exception {
        Map<String, Object> exec = exec(connectionStr, "select * from %s where 《whereStr》".formatted(tableName), List.of(new HashMap<>(){{
            put("filter",new ArrayList<Map<String,Object>>(){{
                add(new HashMap<>(){{
                    put("left","(");
                    put("column","id");
                    put("comparator","=");
                    put("value",15);
                    put("right",")");
                }});
            }});
        }}), "0", filterColumns, filterLines);
        System.out.println(DataFormatUtil.toString(exec));
    }
}